/* ASIZE.C    ver 1.11b
   Dave Harris
   Compiled using Turbo C ver 2.0
   01-23-90 */

#include "version.c"
/*********************************************************************/
#if USE_IBM
   typedef int FILE_N;      /* Corresponding to a handle */
#else
   typedef FILE* FILE_N;
#endif
/*********************************************************************/
/* Function declaration */

void parse_filename(),stats(),size(),size_lzh(),size_zip(),size_pak(),
   size_dwc(),size_zoo();
char *long_to_string();
int minimum();
long string_to_long();
/*********************************************************************/

/* -1 is non-commital for these parameters */

char smart=1;                  /* 0 - off, 1 - on, 2 - always */
char self_extracts=-1;         /* 0 - off, 1 - on */

char source_directory[FLENGTH];/* Source directory */
char cur_directory[FLENGTH];   /* Current directory */
char dest_directory[FLENGTH];  /* Work Directory */
char work_file[FLENGTH];
char use_maximum=TRUE;         /* max or minimum date */

long totsize[9],fsize[9],count[9],gsize;
int best_ratio=999;

typedef struct file_stack FILES;
struct file_stack {            /* holds a directory listing */
   char string[13];
   FILES *next;
};

FILES *head,*tail,*temp_hold;
struct ffblk ffblk;            /* directory entry structure */
/***********************************************************************/

#if USE_IBM
   #include "ibmdos.c"
#else
   #include "macros.c"
#endif

#define USE_CD               TRUE     /* which functions are needed out of */
#define USE_OPENCFG          FALSE     /* universe.c */
#define USE_GET_FORMAT       TRUE
#define USE_END_OF_LINE      TRUE
#define USE_GET_FILE_LINE    TRUE
#define USE_LTRIM            TRUE
#define USE_CHECK_FOR_KEY    TRUE
#define USE_SPLIT_STRING     FALSE
#include "universe.c"    /* universal functions used in all the programs */
#include "self.c"
/***********************************************************************/
main(argc,argv)
int argc;
char *argv[];
{
   char string[120],look_through[15];
   FILE_N file,list;
   int i,done,is_list=FALSE;

/*********************************************************************/
/* Title */

   for (i=0;i<8;i++)
      totsize[i]=fsize[i]=0;

   my_printf(VERSION);
   my_printf("Archive Sizer\n\n");

/*********************************************************************/
/* Parse the command line parameters */

   {
      int the_files=FALSE,option;
      char *cur_argv;

      for (i=1;i<argc;i++) {
         cur_argv=argv[i];    /* reduce all those argv[i] to an exact address */
         strupr(cur_argv);
         if (cur_argv[0]=='-' || cur_argv[0]=='/') {  /* dash option */
            option=cur_argv[1];
            if (cur_argv[2]==NULL)    /* parameter continues on next */
               cur_argv = argv[++i];
            else
               cur_argv+=2;           /* advance it 2 characters */
            if (option=='S') {       /* Smart mode on/off/always */
               if (stricmp(cur_argv,"ON")==0)
                  smart=1;
               else if (stricmp(cur_argv,"ALWAYS")==0)
                  smart=2;
               else
                  smart=0;
            }
            else if (option=='X')
               self_extracts = stricmp(cur_argv,"ON")==0;
            else if (option=='W')
               strcpy(dest_directory,cur_argv);
            else if (option=='?') {
               my_printf("Command line parameters:\n-----------------------\n");
               my_printf("-son / -soff / -salways  Smart_mode on/off/always\n");
               my_printf("-xon / -xoff  self eXtracts on/off\n");
               my_printf("-w work/directory\n");
               exit (0);
            }
            else {
               my_printf("Invalid Command Line Parameter");
               string[0]=option;
               string[1]=NULL;
               my_printf(string);
               my_printf("\n");
               exit(0);
            }
         }
         else {                  
            if (!the_files) {    /* specifying the file(s) to unarc */

               parse_filename(cur_argv);
               the_files=TRUE;
               strcpy(look_through,cur_argv);
               if (look_through[0]=='@') {
                  char string[FLENGTH];
                  string[0]=NULL;
                  if (source_directory[0]!=NULL) {
                     strcpy(string,source_directory);
                  }
                  strcat(string,&look_through[1]);
                  is_list=TRUE;
                  list = my_fopen(string);
                  if (list==NULL) {
                     my_printf("@");
                     my_printf(string);
                     my_printf(" not found\n");
                     exit(1);
                  }
               }
            }
         }
      }
      getcwd(cur_directory,FLENGTH);        /* hold onto the current directory */
      cd(dest_directory);
      getcwd(dest_directory,FLENGTH);
      strcpy(work_file,dest_directory);
      if (work_file[strlen(work_file)-1]!='\\')
         strcat(work_file,"\\");
      strcat(work_file,"temp89.dat");

      cd(cur_directory);
/*****************************************************************/
next_files:

      if (is_list) {
         char string[FLENGTH];
         get_file_line(list,string);
         if (string[0]==NULL)
            goto next_files;
         if (string[0]==EOF) {
            my_fclose(list);
            goto end_prog;
         }
         parse_filename(string);
         strcpy(look_through,string);
      }

      if (look_through[0]==NULL || !the_files)
         strcpy(look_through,"*.*");

      if (!strstr(look_through,"."))
         strcat(look_through,".*");
   }

/*************************************************************************/
/* Get all the directory hokus pocus out of the way */


   cd(source_directory);
   getcwd(source_directory,FLENGTH);  /* Restore it so we get full path name */

/********************************************************************/
/* get all the file names and put them on the queue */

   if (findfirst(look_through,&ffblk,0)) {
      if (is_list)
         goto next_files;
      else
         goto end_prog;
   }
   head=(FILES*)malloc(sizeof(FILES));
   strcpy(head->string,ffblk.ff_name);
   tail=head;
   while (!findnext(&ffblk)) {
      temp_hold=(FILES*)malloc(sizeof(FILES));
      strcpy(temp_hold->string,ffblk.ff_name);
      tail->next=temp_hold;
      tail=temp_hold;
   }
   tail->next=NULL;
/********************************************************************/

   while (head!=NULL)  {
      strcpy(string,head->string);
      findfirst(string,&ffblk,0);
      gsize=ffblk.ff_fsize;
      size(string);
      check_for_key();
      temp_hold=head;
      head=head->next;
      free(temp_hold);              /* clean up behind */
   }
   if (is_list)
      goto next_files;


/**********************************************************************/
end_prog:
   unlink(work_file);
   cd(cur_directory);

   {
      long size1=0,size2=0,totcount=0;
      int i;

      my_printf("Total Sizes of files:\n");
      my_printf("-------------------------------------------------------\n");
      my_printf("Type     Number   Compressed    UnCompressed  % savings\n");
      my_printf("--------------------------------------------------------\n");
      if (totsize[0]!=0)
         stats(".LZH = ",count[0],fsize[0],totsize[0]);
      if (totsize[6]!=0)
         stats(".LZS = ",count[6],fsize[6],totsize[6]);
      if (totsize[1]!=0)
         stats(".PAK = ",count[1],fsize[1],totsize[1]);
      if (totsize[2]!=0)
         stats(".ZIP = ",count[2],fsize[2],totsize[2]);
      if (totsize[3]!=0)
         stats(".DWC = ",count[3],fsize[3],totsize[3]);
      if (totsize[4]!=0)
         stats(".ZOO = ",count[4],fsize[4],totsize[4]);
      if (totsize[5]!=0)
         stats(".ARC = ",count[5],fsize[5],totsize[5]);
      if (totsize[7]!=0)
         stats("SlfExt ",count[7],fsize[7],totsize[7]);
      if (totsize[8]!=0)
         stats("NonArc ",count[8],fsize[8],totsize[8]);

      for (i=0;i<9;i++) {
         size1+=fsize[i];
         size2+=totsize[i];
         totcount+=count[i];
      }
      if (size1!=0) {
         my_printf("--------------------------------------------------------\n");
         stats("Total  ",totcount,size1,size2);
      }
      my_printf("\nBest file ratio obtained %");
      my_printf(long_to_string((long)best_ratio,3));
      my_printf("\n");
   }
}

/*********************************************************************/
void size(char string[])
{
   int i;

   if ((strstr(string,".COM")!=NULL || strstr(string,".EXE")!=NULL)
      && is_self_extract(string)) {

      char string2[80];
      int done;

      system("md conv89");
      strcpy(string2,"COPY ");
      strcat(string2,string);
      strcat(string2," conv89 >NUL");
      system(string2);
      system("cd conv89");
      {
         int j=0;
         while (TRUE) {
            if (string[j]=='.') {
               string[j]=NULL;
               break;
            }
            j++;
         }
         strcpy(string2,"ECHO Y\nY\nY\nY\nY\nY\nY\nY\nY\nY\nY\nY\n | ");
         strcat(string2,string);
         strcat(string2,">NUL");
         string[j]='.';
         fsize[7]+=gsize;

         system(string2);
         findfirst(string,&ffblk,0);
         if (gsize==ffblk.ff_fsize)
            unlink(string);
      }
      {
         struct ftime ftime_hold;

         done=findfirst("*.*",&ffblk,0);
         while (!done) {
            totsize[7]+=ffblk.ff_fsize;
            done=findnext(&ffblk);
         }
         system("echo Y | del *.* >NUL");
      }
      system("cd ..");
      system("rd conv89");
      return;
   }
   if (smart!=ALWAYS) {
      if (strstr(string,".LZH")!=NULL) {
         size_lzh(string,TRUE);
         return;
      }
      if (strstr(string,".LZS")!=NULL) {
         size_lzh(string,FALSE);
         return;
      }
      else if (strstr(string,".ZIP")!=NULL) {
         size_zip(string);
         return;
      }
      else if (strstr(string,".PAK")!=NULL) {
         size_pak(string,TRUE);
         return;
      }
      else if (strstr(string,".ZOO")!=NULL) {
         size_zoo(string);
         return;
      }
      else if (strstr(string,".ARC")!=NULL) {
         size_pak(string,FALSE);
         return;
      }
      else if (strstr(string,".DWC")!=NULL) {
         size_dwc(string);
         return;
      }
      else if (smart<1) {
         fsize[8]+=gsize;
         totsize[8]+=gsize;
      }
   }
   if (smart>=ON) {
      char format[5];
      strcpy(format,get_format(string));
      if (format[0]=='*') {
         fsize[8]+=gsize;
         totsize[8]+=gsize;
      }
      else if (strstr(format,".LZH")!=NULL)
         size_lzh(string,TRUE);
      else if (strstr(format,".LZS")!=NULL)
         size_lzh(string,FALSE);
      else if (strstr(format,".ZIP")!=NULL)
         size_zip(string);
      else if (strstr(format,".PAK")!=NULL)
         size_pak(string,TRUE);
      else if (strstr(format,".ZOO")!=NULL)
         size_zoo(string);
      else if (strstr(format,".ARC")!=NULL)
         size_pak(string,FALSE);
      else if (strstr(format,".DWC")!=NULL)
         size_dwc(string);
   }
   return;
}
/******************************************************************/
void size_lzh(char string[],char is_lzh)
{
   char string2[FLENGTH];    /* build the dos commands in the string */
   FILE_N file;
   long temp=0;

   strcpy(string2,"LHARC v ");
   strcat(string2,string);
   strcat(string2," >");
   strcat(string2,work_file);
   system(string2);

   file=my_fopen(work_file);
   my_fseek(file,-44,2);

   temp=string_to_long(file);
   if (is_lzh) {
      totsize[0]+=temp;
      fsize[0]+=gsize;
      count[0]++;
   }
   else {
      totsize[6]+=temp;
      fsize[6]+=gsize;
      count[6]++;
   }
   best_ratio = minimum(best_ratio,(int)((gsize*100l)/temp));
   my_fclose(file);
   return;
}
/******************************************************************/
void size_pak(char string[],char is_pak)
{
   char string2[FLENGTH];    /* build the dos commands in the string */
   FILE_N file;
   long temp=0;

   strcpy(string2,"PAK v ");
   strcat(string2,string);
   strcat(string2," >");
   strcat(string2,work_file);
   system(string2);

   file=my_fopen(work_file);
   my_fseek(file,-52,2);

   temp=string_to_long(file);
   if (is_pak) {
      totsize[1]+=temp;
      fsize[1]+=gsize;
      count[1]++;
   }
   else {
      totsize[5]+=temp;
      fsize[5]+=gsize;
      count[5]++;
   }
   best_ratio = minimum(best_ratio,(int)((gsize*100l)/temp));
   my_fclose(file);
   return;
}
/******************************************************************/
void size_zip(char string[])
{
   char string2[FLENGTH];    /* build the dos commands in the string */
   FILE_N file;
   long temp=0;

   strcpy(string2,"PKUNZIP -v ");
   strcat(string2,string);
   strcat(string2," >");
   strcat(string2,work_file);
   system(string2);

   file=my_fopen(work_file);
   my_fseek(file,-70,2);

   temp=string_to_long(file);
   totsize[2]+=temp;
   fsize[2]+=gsize;
   count[2]++;
   best_ratio = minimum(best_ratio,(int)((gsize*100l)/temp));
   my_fclose(file);
   return;
}
/******************************************************************/
void size_dwc(char string[])
{
   char string2[FLENGTH];    /* build the dos commands in the string */
   FILE_N file;
   long temp=0;

   strcpy(string2,"DWC v ");
   strcat(string2,string);
   strcat(string2," >");
   strcat(string2,work_file);
   system(string2);

   file=my_fopen(work_file);
   my_fseek(file,-35,2);

   temp=string_to_long(file);
   totsize[3]+=temp;
   fsize[3]+=gsize;
   count[3]++;
   best_ratio = minimum(best_ratio,(int)((gsize*100l)/temp));
   my_fclose(file);
   return;
}
/******************************************************************/
void size_zoo(char string[])
{
   char string2[FLENGTH];    /* build the dos commands in the string */
   FILE_N file;
   long temp=0;

   strcpy(string2,"ZOO v ");
   strcat(string2,string);
   strcat(string2," >");
   strcat(string2,work_file);
   system(string2);

   file=my_fopen(work_file);
   my_fseek(file,-35,2);

   temp=string_to_long(file);
   totsize[4]+=temp;
   fsize[4]+=gsize;
   count[4]++;
   best_ratio = minimum(best_ratio,(int)((gsize*100l)/temp));
   my_fclose(file);
   return;
}
/*****************************************************************/
void parse_filename(char filename[])
{
   int j,k=0;

   for (j=strlen(filename);j>=0;j--) {
      if (filename[j]=='\\' || filename[j]==':')  {
         while (k<=j) {
            source_directory[k]=filename[k];
            filename[k]=' ';
            k++;
         }
         ltrim(filename);
         source_directory[k]=NULL;
         if (source_directory[k-1]!='\\')
            strcat(source_directory,"\\");
         break;
      }
   }
}
/***********************************************************************/
char *long_to_string(long l,int n)
{
   static char string[11];
   long temp[10];
   int i,nonzero=FALSE;

   temp[0]=1;
   for (i=1;i<n;i++)
      temp[i]=temp[i-1]*10;

   for (i=n;i>=0;i--) {
      if (temp[i]>l) {
         if (nonzero)
            string[n-i]='0';
         else
            string[n-i]=' ';
      }
      else {
         nonzero=TRUE;
         string[n-i]=48+l/temp[i];
         l=l-l/temp[i]*temp[i];
      }
   }
   string[n+1]=NULL;
   if (string[n]==' ')
      string[n]='0';

   return string;
}
/*********************************************************************/
void stats(char string[],long count,long fsize,long totsize)
{
   my_printf(string);
   my_printf(long_to_string(count,6));
   my_printf(" |  ");
   my_printf(long_to_string(fsize,9));
   my_printf(" |  ");
   my_printf(long_to_string(totsize,9));
   my_printf(" |  ");
   if (totsize>99l)
      my_printf(long_to_string(100l-(fsize/(totsize/100l)),3));
   else if (totsize!=0)
      my_printf(long_to_string(100l-(fsize*100l/totsize),3));
   my_printf("\n");
   return;
}
/***********************************************************************/
long string_to_long(FILE_N file)
{
   int i,c;
   long temp=0;

   for (i=0;i<11;i++) {
      c=my_getc(file);
      if (c>'9')  {                   /* error condition */
         my_fclose(file);
         return 0;
      }
      if (c!=' ')
         temp=temp*10+(c-48);
   }
   return temp;
}
/************************************************************************/
int minimum(int x,int y)
{
   if (x<y)
      return x;
   else
      return y;
}
