/* BBS Sweep    ver 1.11b
   Dave Harris
   Compiled using Turbo C ver 2.0
   01-23-90 */

#include "version.c"
/*********************************************************************/
#if USE_IBM
   typedef int FILE_N;      /* Corresponding to a handle */
#else
   typedef FILE* FILE_N;
#endif

void execute();
/************************************************************************/
char source_directory[FLENGTH];
char cur_directory[FLENGTH];
char command[FLENGTH];
char pause=-1;
char greater_than='}';
char less_than='{';
char pipe='~';
/************************************************************************/
#if USE_IBM
   #include "ibmdos.c"
#else
   #include "macros.c"
#endif

#define USE_CD               TRUE     /* which functions are needed out of */
#define USE_OPENCFG          FALSE    /* universe.c */
#define USE_GET_FORMAT       FALSE
#define USE_END_OF_LINE      FALSE
#define USE_GET_FILE_LINE    FALSE
#define USE_LTRIM            TRUE
#define USE_CHECK_FOR_KEY    TRUE
#define USE_SPLIT_STRING     FALSE
#include "universe.c"    /* universal functions used in all the programs */
/***********************************************************************/
main(int argc,char *argv[])
{
   FILE_N file,file2;
   struct ffblk ffblk;
   int done,i;
   char sysfile[99][13];
   char temphold[120];
   char *cur_argv,option;

   for (i=1;i<argc;i++) {
      cur_argv=argv[i];
      strupr(cur_argv);
      if (cur_argv[0]=='-' || cur_argv[0]=='/') {  /* dash option */
         option=cur_argv[1];
         if (cur_argv[2]==NULL)    /* parameter continues on next */
            cur_argv = argv[++i];
         else
            cur_argv+=2;           /* advance it 2 characters */

         if (option=='B')
            pause=stricmp(cur_argv,"ON")==0;
         if (option=='G')
            greater_than=cur_argv[0];
         if (option=='L')
            less_than=cur_argv[0];
         if (option=='P')
            pipe=cur_argv[0];
         if (option=='?') {
             my_printf("Command line parameters:\n-----------------------\n");
             my_printf("-bon / -soff  Break at each directory on/off\n");
             my_printf("-gC  Greater than character, default = }\n");
             my_printf("-lC  Less than character, default = { \n");
             my_printf("-pC  Pipe character, default = ~\n");
             my_printf("Where C is one character\n");
             exit (0);
         }

      }
      else
         break;
   }
   if (i>=argc) {
      my_printf("Missing Command\n");
      exit (1);
   }
   strcpy(command,argv[i]);
   for (i=i+1;i<argc;i++) {
      strcat(command," ");
      strcat(command,argv[i]);
   }
   done=strlen(command);
   for (i=0;i<done;i++) {
      if (command[i]==greater_than)
         command[i]='>';
      else if (command[i]==less_than)
         command[i]='<';
      else if (command[i]==pipe)
         command[i]='|';
   }

   my_printf(VERSION);
   my_printf("BBS Sweep\n\n");

   getcwd(cur_directory,FLENGTH);        /* hold onto the current directory */
/************************************************************************/

   done=findfirst("system*.bbs",&ffblk,0);
   if (done) {                               /* GT Powercomm */
      file=my_fopen("gtdir.bbs");
      if (file==NULL) {
         my_printf("No .bbs files to process in this directory\n");
         exit(1);
      }
      while (TRUE) {
         int c;
         while (TRUE) {         /* go until a space is hit */
            c=my_getc(file);
            if (c==EOF)
               goto end_prog;
            if (c<=' ')
               break;
         }
         while (TRUE) {        /* go until a non-space is hit */
            c=my_getc(file);
            if (c==EOF)
               goto end_prog;
            if (c>' ')
               break;
         }
         i=0;
         while (TRUE) {
            source_directory[i++]=c;
            c=my_getc(file);
            if (c==EOF)
               goto end_prog;
            if (c<=' ')
               break;
         }
         source_directory[i]=NULL;
         execute();
         while (TRUE) {          /* pass over the description */
            c=my_getc(file);
            if (c==EOF)
               goto end_prog;
            if (c=='\n')
               break;
         }
      }
      end_prog:
      return;
   }
   else {                      /* OPUS */
      for (i=0;i<99;i++)       /* Init the variables */
         sysfile[i][0]=NULL;
      i=0;
      while (!done) {
         strcpy(sysfile[i++],ffblk.ff_name);
         done=findnext(&ffblk);
      }
   /************************************************************************/
   /* Sort the dang list */  /* ok, ok I know the selection sort sucks */
      {
         int j,k,l,m;
         for (j=0;j<i;j++) {
            for (k=j+1;k<i;k++) {
               l=atoi(&sysfile[j][6]);
               m=atoi(&sysfile[k][6]);
               if (l>m) {                  /* swap places */
                  strcpy(temphold,sysfile[j]);
                  strcpy(sysfile[j],sysfile[k]);
                  strcpy(sysfile[k],temphold);
               }
            }
         }
      }
   /************************************************************************/
   /* open up the system files one at a time and pick off the download dir */
      i=0;
      while (sysfile[i][0]!=NULL) {
         if (strlen(sysfile[i])<11) {
            i++;
            continue;
         }
         file=my_fopen(sysfile[i]);
         my_fseek(file,164,0);
         {
            int c,i=0;
            while ((c=my_getc(file))!=' ') {
               if (c==EOF)
                  break;
               source_directory[i++]=c;
            }
            source_directory[i]=NULL;
         }
         my_fclose(file);
         if (source_directory[0]>33) {
            execute();
         }
         i++;
      }
   }
}
/************************************************************************/
void execute()
{
   my_printf("Processing ");
   my_printf(source_directory);
   my_printf("\n");
   check_for_key();
   if (pause==TRUE) {
      my_printf("Press a Key to continue:");
      my_getch();
      my_printf("\n");
   }
   cd(source_directory);
   system(command);
   cd(cur_directory);
}

