/* CONVERT.C  ver 1.11b
   Dave Harris
   Compiled using Turbo C ver 2.0
   01-23-90 */

#include "version.c"
/***********************************************************************/
#define NO_UNARCS       20
#define NO_ARCS         20

/***********************************************************************/
#if USE_IBM    /* Low Level Functions defined in ibmdos.c */
   typedef int FILE_N;      /* Corresponding to a handle */
#else
   typedef FILE* FILE_N;
#endif
FILE_N opencfg();

char is_self_extract();

int unarc(),scan(),fcount(),unarc_one(),test_pak2(),test_zip1();

void push(),clean(),recursive(),rearchive(),my_fputs(),
     get_string(),dump(),parse_ctl(),fix_file_list();

char *long_to_string();

struct ftime *date_ret();
/***********************************************************************/
char recurse;             /* Recursion on/off */
char smart;               /* 0 - off, 1 - on, 2 - always */
char redirect_to[FLENGTH];/* ie >Nul */
char date_retain;         /* 0 - off, 1 - on, 2 - last, 3 - first*/
char summary;             /* Disk savings/time summary on/off */
char keep_smallest;       /* keep the smallest on/off */
char keep_old;            /* keep the old archive ON/OFF/BENCH*/
char self_extracts;       /* allow for self extracts */
char conv_pak2;           /* convert 2.xx paks */
char conv_zip1;           /* convert 1.xx zips */
char cfgfile[FLENGTH];    /* configuration file to use */
char file_list[FLENGTH];  /* file list to patch */
char execute[FLENGTH];    /* execute this after each unarc */
char arc_number=0;        /* -n option holder */
int num_convert=32000;    /* convert em all as default */
char md=FALSE;            /* whether or not conv89 was made */

char dest_directory[FLENGTH];  /* Destination directory */
char source_directory[FLENGTH];/* Source directory */
char cur_directory[FLENGTH];   /* Current directory */
char *chosen_directory;        /* switch out the dest_directory */
char ramdrive[FLENGTH];        /* Ram Drive */
long ramdrive_size;

char before[13];          /* File Name before it changed */

int number=0,             /* number of unarc methods specified in .CFG file */
    number2=0;            /* number of arc methods specified */

char ext[NO_UNARCS][5],*method[NO_UNARCS],ext2[NO_ARCS][5],*method2[NO_ARCS];

char look_through[15];

typedef struct file_stack FILES;
struct file_stack {              /* holds a directory listing */
   char string[13];
   FILES *next;
};
FILES *head,*tail,*temp_hold,*done_head,*done_tail;

long time_spent[20],
     temp_time1,temp_time2,start_time,end_time;

char string2[120];  /* used as temporary storage all over the place */
/**********************************************************************/
#if USE_IBM
   #include "ibmdos.c"
#else
   #include "macros.c"
#endif

#define USE_CD               TRUE     /* which functions are needed out of */
#define USE_OPENCFG          TRUE     /* universe.c */
#define USE_GET_FORMAT       TRUE
#define USE_END_OF_LINE      TRUE
#define USE_GET_FILE_LINE    TRUE
#define USE_LTRIM            TRUE
#define USE_CHECK_FOR_KEY    TRUE
#define USE_SPLIT_STRING     TRUE
#include "universe.c"
#include "self.c"
/*********************************************************************/
main(argc,argv)
int argc;
char *argv[];
{
   char string[120],last_archive[15];
      
   FILE_N file;
   int i,j,done,handle;
   long old_size,savings[NO_ARCS],best_size;

   struct ftime *ftime_hold;
   struct dfree before_free,after_free;
   struct ffblk ffblk;               /* keep this at this level */

   time(&start_time);           /* begin time */
/************************************************************************/
/* Title */
   my_printf(VERSION);
   my_printf("Archive Format Converter\n");
   my_printf("Type CONVERT -? for help\n\n");

   parse_comm_line(argc,argv);

   if (cfgfile[0]==NULL)
      file=opencfg("AU.CFG");
   else
      file=opencfg(cfgfile);
/*************************************************************************/
/* Get all the directory hokus pocus out of the way */

   getcwd(cur_directory,FLENGTH);        /* hold onto the current directory */

   cd(source_directory);
   getcwd(source_directory,FLENGTH);  /* Restore it so we get full path name */
   if (source_directory[strlen(source_directory)-1]!='\\')
      strcat(source_directory,"\\");

   cd(cur_directory);
   if (dest_directory[0]==NULL) {
      strcpy(dest_directory,"conv89");
      system("md conv89");
      md=TRUE;
   }
   cd (dest_directory);
   if (!findfirst("*.*",&ffblk,0)) {
      my_printf("Work directory is NOT empty\n");
      cd(cur_directory);
      exit(1);
   }
   getcwd(dest_directory,FLENGTH);
   if (dest_directory[strlen(dest_directory)-1]!='\\')
      strcat(dest_directory,"\\");


/**********************************************************************/
/**********************************************************************/
/* parse the configuration file for the control info */

   while (TRUE) {
      get_file_line(file,string);
      if (string[0]==EOF)
         break;
      if (string[0]==NULL)
         continue;
      if ((string[0]=='U' || string[0]=='u') && string[1]<=' ') {
         string[0]=string[1]=' ';
         ltrim(string);
         split_string(string,ext[number]);
         method[number]=(char*)malloc(strlen(string)+1);
         strcpy(method[number],string);
         strupr(ext[number]);
         number++;
      }
      else if ((string[0]=='A' || string[0]=='a') && string[1]<=' ') {
         string[0]=string[1]=' ';
         ltrim(string);
         split_string(string,ext2[number2]);
         method2[number2]=(char*)malloc(strlen(string)+1);
         strcpy(method2[number2],string);
         strupr(ext2[number2]);
         savings[number2]=0;
         time_spent[number2]=0;
         number2++;
      }
      else {
         char string2[50],string3[15];
         split_string(string,string3);
         split_string(string,string2);
         if (stricmp(string3,"begin")==0 && stricmp(string2,"convert")!=0) {
            while (TRUE) {
               get_file_line(file,string);
               if (string[0]==EOF)
                  break;
               if (string[0]==NULL)
                  continue;
               split_string(string,string3);
               split_string(string,string2);
               if (stricmp(string3,"begin")==0 && stricmp(string2,"convert")==0)
                  break;
            }
         }
         else if (stricmp(string3,"smart_mode")==0) {
            if (stricmp(string2,"ON")==0)
               smart=1;
            else if (stricmp(string2,"ALWAYS")==0)
               smart=2;
            else
               smart=0;
         }
         else if (stricmp(string3,"date_retain")==0) {
            if (stricmp(string2,"ON")==0)
               date_retain=1;
            else if (stricmp(string2,"LAST")==0)
               date_retain=2;
            else if (stricmp(string2,"FIRST")==0)
               date_retain=3;
            else
               date_retain=0;
         }
         else if (stricmp(string3,"summary")==0) {
            if (stricmp(string2,"ON")==0)
               summary=1;
            else
               summary=0;
         }
         else if (stricmp(string3,"convert_pak2")==0) {
            if (stricmp(string2,"ON")==0)
               conv_pak2=1;
            else
               conv_pak2=0;
         }
         else if (stricmp(string3,"convert_zip1")==0) {
            if (stricmp(string2,"ON")==0)
               conv_zip1=1;
            else
               conv_zip1=0;
         }
         else if (stricmp(string3,"keep_old")==0) {
            if (stricmp(string2,"ON")==0)
               keep_old=1;
            else if (stricmp(string2,"BENCH")==0)
               keep_old=2;
            else
               keep_old=0;
         }
         else if (stricmp(string3,"self_extracts")==0) {
            if (stricmp(string2,"ON")==0)
               self_extracts=1;
            else
               self_extracts=0;
         }
         else if (stricmp(string3,"redirect_to")==0 && redirect_to[0]==NULL) {
            strcpy(redirect_to," >>");
            strcat(redirect_to,string2);
         }
         else if (stricmp(string3,"file_list")==0 && file_list[0]==NULL)
            strcpy(file_list,string2);
         else if (stricmp(string3,"ram_drive")==0 && ramdrive[0]==NULL)
            strcpy(ramdrive,string2);
         else if (stricmp(string3,"execute")==0)  {
            int i=0;
            while (string[i]==' ')
               i++;
            while (string[i]!=' ')
               string[i++]=' ';
            ltrim(string);
            strcpy(execute,string);
         }
         else if (stricmp(string3,"recurse")==0) {
            if (stricmp(string2,"ON")==0)
               recurse=1;
            else
               recurse=0;
         }
      }
   }
   parse_comm_line(argc,argv);

   if (arc_number>0) {
      strcpy(method2[0],method2[arc_number-1]);
      strcpy(ext2[0],ext2[arc_number-1]);
      number2=1;
   }
   if (ramdrive[0]!=NULL) {
      cd (ramdrive);
      if (!findfirst("*.*",&ffblk,0)) {
         my_printf("Ramdrive directory is NOT empty\n");
         cd(cur_directory);
         exit(1);
      }
      getcwd(ramdrive,FLENGTH);
      if (ramdrive[strlen(ramdrive)-1]!='\\')
         strcat(ramdrive,"\\");
      getdfree(0,&before_free);
      ramdrive_size = before_free.df_avail*before_free.df_sclus*
                      before_free.df_bsec;
      my_printf("Ram drive Size = ");
      my_printf(long_to_string(ramdrive_size,8));
      my_printf(" bytes\n");
   }

   cd(source_directory);
   if (summary==1)
      getdfree(0,&before_free);
/***************************************************************************/
/* get all the file names and put them on the queue */

   done=findfirst(look_through,&ffblk,0);
   if (done) {
      my_printf("Nothing to Convert\n");
      cd(cur_directory);
      exit(0);
   }

   head=(FILES*)malloc(sizeof(FILES));
   strcpy(head->string,ffblk.ff_name);
   head->next=NULL;
   tail=head;
   while (!done) {
      done=findnext(&ffblk);
      if (done)
         break;
      temp_hold=(FILES*)malloc(sizeof(FILES));
      strcpy(temp_hold->string,ffblk.ff_name);
      tail->next=temp_hold;
      tail=temp_hold;
      tail->next=NULL;
   }
/****************************************************************************/

   while (head!=NULL)  {
      clean();
      strcpy(string,head->string);

      strcpy(before,string);
      if ((strstr(string,".COM")!=NULL || strstr(string,".EXE")!=NULL)
             && is_self_extract(string)) {
         my_printf("Converting ");
         my_printf(string);
         my_printf("\n");
         findfirst(string,&ffblk,0);
         old_size=ffblk.ff_fsize;

         if (ramdrive[0]!=NULL && old_size<ramdrive_size/10l)
            chosen_directory = ramdrive;
         else
            chosen_directory = dest_directory;

         if (date_retain==1) {
            ftime_hold=date_ret(string);
         }
         strcpy(string2,"COPY ");
         strcat(string2,string);
         strcat(string2," ");
         strcat(string2,chosen_directory);
         strcat(string2," >NUL");
         system(string2);
         cd(chosen_directory);
         {
            int j=0;
            while (1) {
               if (string[j]=='.') {
                  string[j]=NULL;
                  break;
               }
               j++;
            }
            strcpy(string2,"ECHO Y\nY\nY\nY\nY\nY\nY\nY\nY\nY\nY\nY\n | ");
            strcat(string2,string);
            strcat(string2,redirect_to);
            i=fcount();
            system(string2);
            if (execute[0]!=NULL)
               system(execute);

            string[j]='.';                  /* might be a .exe file also */
            findfirst(string,&ffblk,0);
            if (old_size==ffblk.ff_fsize)
               unlink(string);
            if (fcount()>=i) {
               goto archive;
            }
            else {
               cd(source_directory);
               goto around;
            }
         }
      }

      if (smart==2)
         goto start_smart;

      for (i=0;i<number;i++) {
         if (strstr(string,ext[i])!=NULL) {
            if (stricmp(ext[i],".PAK")==0 && conv_pak2==0 &&
               stricmp(ext2[0],".PAK")==0 && test_pak2(string))
               goto around;
            if (stricmp(ext[i],".ZIP")==0 && conv_zip1==0 &&
               stricmp(ext2[0],".ZIP")==0 && test_zip1(string))
               goto around;
            my_printf("Converting ");
            my_printf(string);
            my_printf("\n");

            findfirst(string,&ffblk,0);
            old_size=ffblk.ff_fsize;

            if (ramdrive[0]!=NULL && old_size<ramdrive_size/10l)
               chosen_directory = ramdrive;
            else
               chosen_directory = dest_directory;

            if (date_retain==1) {
               ftime_hold=date_ret(string);
            }
            cd(chosen_directory);
            strcpy(string2,method[i]);       /* duplicate code */
            strcat(string2," ");
            strcat(string2,source_directory);
            strcat(string2,string);
            strcat(string2,redirect_to);
            i=fcount();
            system(string2);
            if (execute[0]!=NULL)
               system(execute);
            if (fcount()>i) {
               goto archive;
            }
            else {
               cd(source_directory);
               goto around;
            }
         }
      }

start_smart:

      if (smart>0) {
         char format[5];
         strcpy(format,get_format(string));
         if (format[0]!=NULL) {
            for (i=0;i<number;i++) {
               if (strstr(format,ext[i])!=NULL) {
                 if (stricmp(ext[i],".PAK")==0 && conv_pak2==0 &&
                    stricmp(ext2[0],".PAK")==0 && test_pak2(string))
                    goto around;
                 if (stricmp(ext[i],".ZIP")==0 && conv_zip1==0 &&
                    stricmp(ext2[0],".ZIP")==0 && test_zip1(string))
                    goto around;
                  my_printf("Converting ");
                  my_printf(string);
                  my_printf("\n");
                  findfirst(string,&ffblk,0);
                  old_size=ffblk.ff_fsize;
                  if (ramdrive[0]!=NULL && old_size<ramdrive_size/10l)
                     chosen_directory = ramdrive;
                  else
                     chosen_directory = dest_directory;

                  if (date_retain==1) {
                     ftime_hold=date_ret(string);
                  }
                  cd(chosen_directory);
                  strcpy(string2,method[i]);       /* duplicate code */
                  strcat(string2," ");
                  strcat(string2,source_directory);
                  strcat(string2,string);
                  strcat(string2,redirect_to);
                  i=fcount();
                  system(string2);
                  if (execute[0]!=NULL)
                     system(execute);

                  if (fcount()>i) {
                     goto archive;
                  }
                  else {
                     cd(source_directory);
                     goto around;
                  }
               }
            }
         }
      }
goto around;
archive:

      if (recurse==1) {        /* takes care of arcs within arcs */
         recursive();
      }

      cd(source_directory);
      strcpy(last_archive,string);
      best_size=old_size;
      for (i=0;i<number2;i++) {
         j=0;
         while (1) {
            if (string[j]=='.') {
               string[j]=NULL;
               strcat(string,ext2[i]);
               break;
            }
            j++;
         }
         strcpy(string2,method2[i]);
         strcat(string2," ");
         strcat(string2,string);
         strcat(string2," ");
         strcat(string2,chosen_directory);
         strcat(string2,"*.*");
         strcat(string2,redirect_to);
         if (stricmp(string,last_archive)==0) {
            unlink(string);
         }
         if (keep_smallest<1 && ((number2==1 && keep_old!=1) || number2>1 && keep_old<1))
            unlink(last_archive);

         time(&temp_time1);
         system(string2);
         time(&temp_time2);
         time_spent[i]+=temp_time2-temp_time1;

         findfirst(string,&ffblk,0);
         if (stricmp(string,last_archive)!=NULL) {
            if (keep_smallest==1) {
               if (ffblk.ff_fsize>best_size) {
                  unlink(string);                /* remove the old file */
                  continue;
               }
               else {
                  unlink(last_archive);
                  strcpy(last_archive,string);
                  best_size=ffblk.ff_fsize;
               }
            }
/*            else if ((number2==1 && keep_old!=1) || number2>1 && keep_old<1)
               unlink(last_archive); */
         }
         savings[i]+=old_size-ffblk.ff_fsize;
         if (date_retain==1) {
            handle=open(string,1);
            setftime(handle,ftime_hold);
            close(handle);
         }
         else if (date_retain==2) {
            strcpy(string2,"redate ");
            strcat(string2,string);
            strcat(string2," >NUL");
            system(string2);
         }
         else if (date_retain==3) {
            strcpy(string2,"redate -l");
            strcat(string2,string);
            strcat(string2," >NUL");
            system(string2);
         }
      }
      if (date_retain==1)
         free(ftime_hold);

      cd(chosen_directory);
      system("echo Y | del *.* >NUL");
      cd(source_directory);

      if (file_list[0]!=NULL)
         fix_file_list(before,string);

      check_for_key();

around:
      temp_hold=head;
      head=head->next;
      free(temp_hold);          /* clean up behind */

      num_convert--;
      if (num_convert==0)
         break;
   }
   if (md) {
      cd(cur_directory);
      system("rd conv89");
   }

   if (summary==1) {
      int e_mins,e_secs;
      long space_saved,elapsed_time;
      char string2[120],string3[120],string[10];

      getdfree(0,&after_free);

      cd(source_directory);
      space_saved=(long)after_free.df_avail*after_free.df_sclus*after_free.df_bsec-
                  (long)before_free.df_avail*before_free.df_sclus*before_free.df_bsec;

      time(&end_time);
      elapsed_time=end_time-start_time;
      e_mins=elapsed_time/60;
      e_secs=elapsed_time-e_mins*60;

      strcpy(string2,"\nSummary:\n");
      my_printf(string2);
      if (redirect_to[0]!=NULL) {
         strcpy(string3,"Echo ");
         strcat(string3,string2);
         strcat(string3,redirect_to);
         system(string3);
      }

      for (i=0;i<number2;i++) {
         strcat(string2,ext2[i]);
         strcat(string2," method saved ");
         strcat(string2,ltoa(savings[i],string,10));
         strcat(string2," bytes and required ");
         strcat(string2,itoa(time_spent[i],string,10));
         strcat(string2," seconds\n");
         my_printf(string2);
         if (redirect_to[0]!=NULL) {
            strcat(string3,"Echo ");
            strcat(string3,string2);
            strcat(string3,redirect_to);
            system(string3);
         }
      }
      strcpy(string2,"\nEffective disk space saved is ");
      strcat(string2,ltoa(space_saved,string,10));
      strcat(string2,"\nTotal Elapsed time is ");
      strcat(string2,itoa(e_mins,string,10));
      strcat(string2,e_secs<10 ? ":0" : ":");
      strcat(string2,itoa(e_secs,string,10));
      strcat(string2,"\n");
      my_printf(string2);
      if (redirect_to[0]!=NULL) {
         strcat(string3,"Echo ");
         strcat(string3,string2);
         strcat(string3,redirect_to);
         system(string3);
      }
   }
   cd(cur_directory);
}

/*************************************************************************/
/*************************************************************************/
void recursive()
{

   int i,j,done;

   FILES *temp_head,*temp_tail;
   struct ftime *ftime_hold;
   struct ffblk ffblk;


   temp_head=done_head;           /* a fake stack so to speak */
   temp_tail=done_tail;

   done_head=done_tail=NULL;

   system("md conv89");

top:
   while (1) {
      int any=0;
      done=findfirst("*.*",&ffblk,0);
      if (!done) {
         if (scan(ffblk.ff_name)==0) {
            if (date_retain==1) {
               ftime_hold=date_ret(ffblk.ff_name);
            }
            any=unarc(ffblk.ff_name);
            if (any) {
               cd("conv89");
               recursive();
               cd("..");
               rearchive(ffblk.ff_name,ftime_hold);
            }
            else
               push(ffblk.ff_name);
            continue;
         }
         while (1) {
            done=findnext(&ffblk);
            if (done)
               break;
            if (scan(ffblk.ff_name)==0) {
               if (date_retain==1) {
                  ftime_hold=date_ret(ffblk.ff_name);
               }
               any=unarc(ffblk.ff_name);
               if (any) {
                  cd("conv89");
                  recursive();
                  cd("..");
                  rearchive(ffblk.ff_name,ftime_hold);
               }
               else
                   push(ffblk.ff_name);
               goto top;
            }
         }
      }
      if (!any)
         break;
   }

   clean();
   done_head=temp_head;
   done_tail=temp_tail;

   system("rd conv89");

}
/**********************************************************/
void rearchive(char string[],struct ftime *ftime_hold)
{
   int j,done,handle;
   long old_size;
   char last_archive[15];
   struct ffblk ffblk;

   findfirst(string,&ffblk,0);
   old_size=ffblk.ff_fsize;
   strcpy(last_archive,string);

   j=0;
   while (1) {
      if (string[j]=='.') {
         string[j]=NULL;
         strcat(string,ext2[0]);
         break;
      }
      j++;
   }
   strcpy(string2,method2[0]);
   strcat(string2," ");
   strcat(string2,string);
   strcat(string2," CONV89\\*.*");
   strcat(string2,redirect_to);
   if (stricmp(string,last_archive)==0) {  /* remove original if redoing */
      unlink(string);
   }
   time(&temp_time1);
   system(string2);
   time(&temp_time2);

   findfirst(string,&ffblk,0);
   if (stricmp(string,last_archive)!=0) {
      if (keep_smallest==1 && ffblk.ff_fsize > old_size) {
         unlink(string);
         strcpy(string,last_archive);
      }
      else {
         unlink(last_archive);
      }
   }
   time_spent[0]+=temp_time2-temp_time1;

   system("echo Y | del conv89\\*.* >NUL");
   if (date_retain==1) {
       handle=my_fopen(last_archive);
       setftime(handle,ftime_hold);
       my_fclose(handle);
       free(ftime_hold);
   }
   else if (date_retain==2) {
      strcpy(string2,"redate ");
      strcat(string2,string);
      strcat(string2," >NUL");
      system(string2);
   }
   else if (date_retain==3) {
      strcpy(string2,"redate -l");
      strcat(string2,string);
      strcat(string2," >NUL");
      system(string2);
   }
   push(string);

}
/***********************************************************************/
struct ftime *date_ret(char string[])
{
   struct ftime *ftime_hold;
   int handle;

   ftime_hold=(struct ftime*)malloc(sizeof(struct ftime));
   handle=my_fopen(string);
   getftime(handle,ftime_hold);
   my_fclose(handle);
   return ftime_hold;
}
/***********************************************************************/
void fix_file_list(char before[],char after[])
{
   FILE_N file;
   long pos,pos2;
   int c,d,i;
   union REGS regs;

   buffer_pointer=0;
   regs.h.ah=0x3d;
   regs.x.dx=(int)file_list;
   regs.h.al=2;                     /* both read and write */
   intdos(&regs,&regs);
   if (regs.x.cflag) {
      if (regs.x.ax==2 || regs.x.ax==3) { /* File not found */
         my_printf("File Listing File ");
         my_printf(file_list);
         my_printf(" Not Found");
         return;
      }
      else {
         char string[2];

         my_printf("Dos File Error In File Listing File #");
         string[0]=regs.x.ax+48;
         string[1]=NULL;
         my_printf(string);
         my_printf("\n");
         exit(1);
      }
   }
   file=regs.x.ax;

   pos = 0;
around:
   while (1) {
      while (1) {
         c=my_getc(file); pos++;
         if (c==EOF)
            goto out_loop;
         else if (c<=' ')   /* skip spaces */
            continue;
         else {
            break;
         }
      }

      pos2=pos-1;

      i=0;
      while (TRUE) {
         if (c<=' ')
            break;
         string2[i++] = c;
         c=my_getc(file); pos++;
      }
      string2[i]=NULL;

      if (stricmp(string2,before)==0) {
         my_fseek(file,pos2,0);
         my_fputs(file,after);              /* write it back out */
         my_fseek(file,pos2+19,0);          /* handle GT */
         c=my_getc(file);
         if (c=='-') {
            my_getc(file); my_getc(file);
            c=my_getc(file);
            if (c=='-') {
               struct ftime ftime_hold;
               FILE_N handle;
               long bytes;

               d=3;
dump:
               handle=my_fopen(after);
               getftime(handle,&ftime_hold);
               bytes=filelength(handle);
               my_fclose(handle);
               if (d==3) {
                  my_fseek(file,pos2+12,0);
                  my_fputs(file,long_to_string(bytes/1024,d));
               }
               else {
                  my_fseek(file,pos2+13,0);
                  my_fputs(file,long_to_string(bytes,d));
               }
               my_fputs(file," ");
               if (ftime_hold.ft_month < 10)
                  my_fputs(file,d==3 ? " " : "0");
               my_fputs(file,itoa(ftime_hold.ft_month,string2,10));
               my_fputs(file,"-");
               if (ftime_hold.ft_day < 10)
                  my_fputs(file,"0");
               my_fputs(file,itoa(ftime_hold.ft_day,string2,10));
               my_fputs(file,"-");
               my_fputs(file,itoa(ftime_hold.ft_year+80,string2,10));
            }
         }
         else {
            my_fseek(file,pos2+25,0);          /* handle RBBS */
            c=my_getc(file);
            if (c=='-') {
               my_getc(file); my_getc(file);
               c=my_getc(file);
               if (c=='-') {
                  d = 8;
                  goto dump;
               }
            }
         }
         my_fseek(file,pos2,0);       /* make darn sure we know where we are */
         pos=pos2;
      }
      while (TRUE) {
         c=my_getc(file); pos++;
         if (c=='\n' || c==EOF)
            break;
      }
   }
out_loop:
   my_fclose(file);
   return;
}
/*************************************************************************/
void push(char string[])  /* push a file onto the already looked at list */
{
   if (done_head==NULL) {
      done_head=(FILES*)malloc(sizeof(FILES));
      done_head->next=NULL;
      strcpy(done_head->string,string);
      done_tail=done_head;
   }
   else {
      temp_hold=(FILES*)malloc(sizeof(FILES));
      temp_hold->next=NULL;
      done_tail->next=temp_hold;
      strcpy(temp_hold->string,string);
      done_tail=temp_hold;
   }
}
/**********************************************************************/
int scan(char string[])
{

   temp_hold=done_head;
   while (temp_hold!=NULL) {
      if (stricmp(string,temp_hold->string)==0)
         return 1;
      temp_hold=temp_hold->next;
   }
   return 0;
}
/*********************************************************************/
int unarc(char string[])
{
   int i;
   long fsize;
   struct ffblk ffblk;

   if ((strstr(string,".COM")!=NULL || strstr(string,".EXE")!=NULL)
         && is_self_extract(string)) {
      my_printf("Unarching");
      my_printf(string);
      my_printf("\n");
      strcpy(string2,"COPY ");
      strcat(string2,string);
      strcat(string2," CONV89");
      system(string2);
      cd("conv89");
      {
         int j=0;
         while (1) {
            if (string[j]=='.') {
               string[j]=NULL;
               break;
            }
            j++;
         }
         strcpy(string2,"ECHO Y\nY\nY\nY\nY\nY\nY\nY\nY\nY\nY\nY\n | ");
         strcat(string2,string);
         strcat(string2,redirect_to);
         string[j]='.';
         findfirst(string,&ffblk,0);
         fsize=ffblk.ff_fsize;
         system(string2);
         if (execute[0]!=NULL)
            system(execute);
         findfirst(string,&ffblk,0);
         if (fsize==ffblk.ff_fsize)
            unlink(string);
      }
      cd("..");
      return 1;
   }
   if (smart==2)                   /* always */
      goto start_smart;

   for (i=0;i<number;i++) {
      if (strstr(string,ext[i])!=NULL)
         return unarc_one(string,i);
   }
start_smart:
   if (smart>0) {
      char format[5];
      strcpy(format,get_format(string));
      if (format[0]!=NULL) {
         for (i=0;i<number;i++) {
            if (strstr(format,ext[i])!=NULL)
               return unarc_one(string,i);
         }
      }
   }
   return 0;
}
/**********************************************************************/
int unarc_one(char string[],int meth_number)
{
   char string2[80];       /* build the dos commands in the string */
   char list[5][80];
   int before,after;

   my_printf("Unarching");
   my_printf(string);
   my_printf("\n");
   cd("conv89");
   strcpy(string2,method[meth_number]);       /* duplicate code */
   strcat(string2," ..\\");
   strcat(string2,string);
   strcat(string2,redirect_to);

   before=fcount();
   system(string2);
   if (execute[0]!=NULL)
      system(execute);
   after=fcount();

   cd("..");
   return (after>before);
}
/**********************************************************************/
void clean()                 /* clean of the directory listing */
{
   while (done_head!=NULL) {
      temp_hold=done_head;
      done_head=done_head->next;
      free(temp_hold);
   }
}
/******************************************************************/
int fcount()                             /* count number of files */
{
   int done,counter=0;
   struct ffblk ffblk;

   done=findfirst("*.*",&ffblk,0);
   while (!done) {
      counter++;
      done=findnext(&ffblk);
   }
   return counter;
}
/***********************************************************************/
int test_pak2(char filename[])
{
   FILE_N file;
   char c,d,e; /* need these because the damn optimizer screws it up */

   file=my_fopen(filename);
   my_fseek(file,-3,2);          /* go to the end of the file -3 bytes */
   c=my_getc(file); d=my_getc(file); e=my_getc(file);
   my_fclose(file);
   return (c=='\\' && d==-2 && e==0);
}
/***********************************************************************/
int test_zip1(char filename[])
{
   char string[50];
   FILE_N file;
   int c,d,e;

   strcpy(string,"pkunzip -v ");
   strcat(string,filename);
   strcat(string," >temp99.dat");
   system(string);
   file=my_fopen("temp99.dat");

   while ((c=my_getc(file))!=EOF) {
      if (c=='I') {
         c=my_getc(file); d=my_getc(file); e=my_getc(file);
         if (c=='m' && d=='p' && e=='l') {
            c=my_getc(file); d=my_getc(file); e=my_getc(file);
            if (c=='o' && d=='d' && e=='e') {
               my_fclose(file);
               unlink("temp99.dat");
               return TRUE;
            }
         }
      }
   }
   my_fclose(file);
   unlink("temp99.dat");
   return FALSE;
}
/********************************************************************/
void parse_comm_line(int argc,char *argv[])
{
/* Parse the command line parameters */
   int the_files=0,i,option,on_off;
   char *cur_argv;

   for (i=1;i<argc;i++) {
      cur_argv=argv[i];    /* reduce all those argv[i] to an exact address */
      strupr(cur_argv);
      if (cur_argv[0]=='-' || cur_argv[0]=='/') {      /* option */
         option=cur_argv[1];
         if (cur_argv[2]==NULL)
            cur_argv = argv[++i];
         else
            cur_argv+=2;     /* advance it 2 characters */

         on_off = stricmp(cur_argv,"ON")==0;
         if (option=='S') {
            if (stricmp(cur_argv,"ALWAYS")==0)
               smart=ALWAYS;
            else
               smart = on_off;
         }
         else if (option=='D') {
            if (stricmp(cur_argv,"LAST")==0)
               date_retain=2;
            else if (stricmp(cur_argv,"FIRST")==0)
               date_retain=3;
            else
               date_retain=on_off;
         }
         else if (option=='R')
            recurse = on_off;
         else if (option=='U')
            summary = on_off;
         else if (option=='K')
            keep_smallest = on_off;
         else if (option=='X')
            self_extracts = on_off;
         else if (option=='P')
            conv_pak2 = on_off;
         else if (option=='Z')
            conv_zip1 = on_off;
         else if (option=='#')
            arc_number = atoi(cur_argv);
         else if (option=='N')
            num_convert = atoi(cur_argv);
         else if (option=='O') {
            strcpy(redirect_to," >>");
            strcat(redirect_to,cur_argv);
         }
         else if (option=='C')
            strcpy(cfgfile,cur_argv);
         else if (option=='L')
            strcpy(file_list,cur_argv);
         else if (option=='?') {
            my_printf("Command line parameters:\n-----------------------\n");
            my_printf("-son / -soff / -salways  Smart_mode on/off/always\n");
            my_printf("-don / -doff / -dlast /-dfirst   Date_retain on/off/last/first\n");
            my_printf("-uon / -uoff  sUmmary on/off\n");
            my_printf("-ron / -roff  Recurse on/off\n");
            my_printf("-kon / -roff  Keep smallest on/off\n");
            my_printf("-xon / -xoff  convert self eXtracts on/off\n");
            my_printf("-pon / -poff  convert Pak 2.xx on/off\n");
            my_printf("-zon / -zoff  convert Zip 1.xx on/off\n");
            my_printf("-#n where n = arcer Number\n");
            my_printf("-nx where x = Number of converts before halting\n");
            my_printf("-l<file>      file Listing file to update\n");
            my_printf("-c<file>      alternate Configuration file\n");
            my_printf("-o<file>      redirect_to Output file\n");
            exit (0);
         }
         else {
            char string[2];
            my_printf("Invalid Command Line Parameter");
            string[0]=option;
            string[1]=NULL;
            my_printf(string);
            exit(0);
         }
      }
      else {
         if (!the_files) {    /* specifying the file(s) to unarc */
            int j,k=0;

            for (j=strlen(cur_argv);j>=0;j--) {
               if (cur_argv[j]=='\\' || cur_argv[j]==':')  {
                  while (k<=j) {
                     source_directory[k]=cur_argv[k];
                     k++;
                  }
                  cur_argv+=k;              /* advance k characters */
                  source_directory[k]=NULL;
                  break;
               }
            }
            the_files=TRUE;
            strcpy(look_through,cur_argv);
         }
         else
            strcpy(dest_directory,cur_argv);
      }
   }
   if (look_through[0]==NULL || !the_files)
      strcpy(look_through,"*.*");

   if (!strstr(look_through,"."))
      strcat(look_through,".*");
}
/***********************************************************************/
void my_fputs(FILE_N handle,char string[])
{
   union REGS regs;

   regs.h.ah=0x40;
   regs.x.bx=handle;
   regs.x.cx=strlen(string);
   regs.x.dx=(int)string;
   intdos(&regs,&regs);
}
/*******************************************************************/
char *long_to_string(long l,int n)
{
   static char string[11];
   long temp[10];
   int i,nonzero=FALSE;

   temp[0]=1;
   for (i=1;i<n;i++)
      temp[i]=temp[i-1]*10;

   for (i=n;i>=0;i--) {
      if (temp[i]>l) {
         if (nonzero)
            string[n-i]='0';
         else
            string[n-i]=' ';
      }
      else {
         nonzero=TRUE;
         string[n-i]=48+l/temp[i];
         l=l-l/temp[i]*temp[i];
      }
   }
   string[n+1]=NULL;
   if (string[n]==' ')
      string[n]='0';

   return string;
}

