/* UNARC.C    ver 1.11b
   Dave Harris
   Compiled using Turbo C ver 2.0
   01-23-90 */

#include "version.c"      /* Globally used defines */
/*********************************************************************/
/* Define Statements */

#define NO_METHODS 20

     /* Maximum number of unarcing methods, I doubt this number will need
        changing too soon */
/*********************************************************************/
/* Function declaration */

#if USE_IBM    /* Low Level Functions defined in ibmdos.c */
   typedef int FILE_N;      /* Corresponding to a handle */
#else
   typedef FILE* FILE_N;
#endif

FILE_N opencfg();
int scan(),unarc(),unarc_one(),fcount();
void push_file();
/*********************************************************************/
char recurse;                  /* Recursive unarching 1 on, 0 off */
char smart;                    /* 0 - off, 1 - on, 2 - always */
char delete_behind;            /* 0 - off, 1 - on */
char self_extracts;            /* 0 - off, 1 - on */
char answer_y;                 /* 0 - off, 1 - on */
char partial[100];             /* patial unarcs */

char redirect_to[FLENGTH];     /* ie >Nul */
char *cfgfile=NULL;            /* configuration file to use */
char dest_directory[FLENGTH];  /* Destination directory */
char source_directory[FLENGTH];/* Source directory */
char cur_directory[FLENGTH];   /* Current directory */

char number=0;                 /* number of unarc methods in .CFG file */

char ext[NO_METHODS][5],       /* extensions ie .ZIP, .LZH  */
     *method[NO_METHODS];      /* unarc methods ie PKUNZIP, LHARC -x */

char look_through[15];         /* Files to process */

typedef struct file_stack FILES;
struct file_stack {            /* holds a directory listing */
   char string[13];
   FILES *next;
};
FILES *head,*tail,*temp_hold,*done_head,*done_tail;

/***********************************************************************/

#if USE_IBM
   #include "ibmdos.c"
#else
   #include "macros.c"
#endif

#define USE_CD               TRUE     /* which functions are needed out of */
#define USE_OPENCFG          TRUE     /* universe.c */
#define USE_GET_FORMAT       TRUE
#define USE_END_OF_LINE      TRUE
#define USE_GET_FILE_LINE    TRUE
#define USE_LTRIM            TRUE
#define USE_CHECK_FOR_KEY    TRUE
#define USE_SPLIT_STRING     TRUE
#include "universe.c"    /* universal functions used in all the programs */
#include "self.c"        /* self extract identify code */
/***********************************************************************/
main(int argc,char *argv[])
{
   char string[120];
   FILE_N file;
   int i,done;
   struct ffblk ffblk;           /* directory entry structure */

/*********************************************************************/
/* Title */

   my_printf(VERSION);
   my_printf("Universal Unarchiver\n");
   my_printf("Type UNARC -? for help\n\n");

   parse_comm_line(argc,argv);
/*****************************************************************/

   if (cfgfile==NULL)         /* while we are still on the cur directory */
      file=opencfg("AU.CFG");
   else
      file=opencfg(cfgfile);     /* if -c specified */

/**********************************************************************/
/* parse the .cfg file for the control info */

   while (TRUE) {
      int on_off;

      get_file_line(file,string);
      if (string[0]==EOF)
         break;

      if (string[0]=='.') {
         split_string(string,ext[number]);
         method[number]=(char*)malloc(strlen(string)+1);
         strcpy(method[number++],string);
      }
      else {
         char string2[50],string3[15];
         split_string(string,string3);
         split_string(string,string2);

         on_off=stricmp(string2,"ON")==0;
         if (stricmp(string3,"begin")==0 && stricmp(string2,"unarc")!=0) {
            while (TRUE) {
               get_file_line(file,string);
               if (string[0]==EOF)
                  break;
               if (string[0]==NULL)
                  continue;
               split_string(string,string3);
               split_string(string,string2);
               if (stricmp(string3,"begin")==0 && stricmp(string2,"unarc")==0)
                  break;
            }
         }
         else if (stricmp(string3,"smart_mode")==0) {
            if (stricmp(string2,"ALWAYS")==0)
               smart=ALWAYS;
            else
               smart = on_off;
         }
         else if (stricmp(string3,"delete_behind")==0)
            delete_behind = on_off;
         else if (stricmp(string3,"recurse")==0)
            recurse = on_off;
         else if (stricmp(string3,"self_extracts")==0)
            self_extracts = on_off;
         else if (stricmp(string3,"redirect_to")==0 && redirect_to[0]==NULL) {
            strcpy(redirect_to," >>");
            strcat(redirect_to,string2);
         }
      }
   }
   my_fclose(file);
   parse_comm_line(argc,argv);
/*************************************************************************/
/* Get all the directory hokus pocus out of the way */

   getcwd(cur_directory,FLENGTH);        /* hold onto the current directory */
   if (source_directory[0]!=NULL && dest_directory[0]==NULL)
      strcpy(dest_directory,cur_directory);

   cd(source_directory);
   getcwd(source_directory,FLENGTH);  /* Restore it so we get full path name */

/********************************************************************/
/* get all the file names and put them on the queue */

   if (findfirst(look_through,&ffblk,0))      /* No files to process */
      goto end_prog;
   head=(FILES*)malloc(sizeof(FILES));
   strcpy(head->string,ffblk.ff_name);
   tail=head;
   while (!findnext(&ffblk)) {
      temp_hold=(FILES*)malloc(sizeof(FILES));
      strcpy(temp_hold->string,ffblk.ff_name);
      tail->next=temp_hold;
      tail=temp_hold;
   }
   tail->next=NULL;

/********************************************************************/
/* put the whole directory on the looked at list so recursion wont
   overrun into the wrong files */

   if (dest_directory[0]!=NULL) {
      cd(dest_directory);
      getcwd(dest_directory,FLENGTH);  /* Restore it so we get full path name */
   }
   findfirst("*.*",&ffblk,0);
   push_file(ffblk.ff_name);
   while (!findnext(&ffblk))
      push_file(ffblk.ff_name);
   cd(source_directory);
/********************************************************************/

   while (head!=NULL)  {
      strcpy(string,head->string);   /* Don't short cut these 2 lines */
      unarc(string);                 /* no matter what */
      temp_hold=head;
      head=head->next;
      free(temp_hold);               /* clean up behind */
   }
/**********************************************************************/
   if (recurse==ON) {         /* takes care of arcs within arcs */

      cd(dest_directory);
      strcpy(source_directory,dest_directory);
      dest_directory[0]=NULL;
      while (TRUE) {
         int any=FALSE;
         done=findfirst("*.*",&ffblk,0);   /* Not necessarily even one file exits */
         while (!done) {
            if (!scan(ffblk.ff_name)) {
               any=unarc(ffblk.ff_name) || any;
               push_file(ffblk.ff_name);
            }
            done=findnext(&ffblk);
         }
         if (!any)
            break;
      }
   }
end_prog:
   cd(cur_directory);
}
/******************************************************************************/
void push_file(char string[])  /* push a file onto the already looked at list */
{
   temp_hold=(FILES*)malloc(sizeof(FILES));
   temp_hold->next=NULL;
   strcpy(temp_hold->string,string);
   if (done_head==NULL)
      done_head=done_tail=temp_hold;
   else {
      done_tail->next=temp_hold;
      done_tail=temp_hold;
   }
}
/**********************************************************************/
int scan(char string[])
{

   temp_hold=done_head;
   while (temp_hold!=NULL) {
      if (stricmp(string,temp_hold->string)==0)
         return TRUE;
      temp_hold=temp_hold->next;
   }
   return FALSE;
}
/*********************************************************************/
int unarc(char string[])
{
   int i;
   char string2[120];
   struct ffblk ffblk;

   if ((strstr(string,".COM")!=NULL || strstr(string,".EXE")!=NULL)
      && is_self_extract(string)) {

      my_printf("Unarching ");
      my_printf(string);
      my_printf("\n");
      if (dest_directory[0]!=NULL) {
         strcpy(string2,"COPY ");
         strcat(string2,string);
         strcat(string2," ");
         strcat(string2,dest_directory);
         strcat(string2," >NUL");
         system(string2);
         cd(dest_directory);
      }
      {
         int j=0;
         long fsize;

         while (TRUE) {
            if (string[j]=='.') {
               string[j]=NULL;
               break;
            }
            j++;
         }

         string2[0]=NULL;
         if (answer_y==TRUE)
            strcat(string2,"ECHO Y\nY\nY\nY\nY\nY\nY\nY\nY\nY\nY\nY\n | ");
         strcat(string2,string);
         strcat(string2,redirect_to);

         string[j]='.';
         findfirst(string,&ffblk,0);    /* get the size of the file */
         fsize=ffblk.ff_fsize;

         i=fcount();
         system(string2);

         if (dest_directory[0]!=NULL && stricmp(source_directory,dest_directory)!=0) {
            findfirst(string,&ffblk,0);    /* get the size of the file */
            i=i-1;
            if (fsize==ffblk.ff_fsize) {    /* only if = do we want to delete */
               i=i-1; /* one less file exists in the directory */
               unlink(string);  /* from the destination directory */
            }
         }
         if (delete_behind==ON && fcount()>i) {  /* delete_behind is needed on this one */
            cd(source_directory);
            findfirst(string,&ffblk,0);    /* get the size of the file */
            if (fsize==ffblk.ff_fsize)     /* only if = do we want to delete */
               unlink(string);
         }
      }
      cd(source_directory);
      return TRUE;
   }

   if (smart!=ALWAYS) {
      for (i=0;i<number;i++) {
         if (strstr(string,ext[i])!=NULL)
            return unarc_one(string,i);
      }
   }
   if (smart>=ON) {
      char format[5];
      strcpy(format,get_format(string));
      for (i=0;i<number;i++) {
         if (strstr(format,ext[i])!=NULL)
            return unarc_one(string,i);
      }
   }
   return FALSE;
}
/**********************************************************************/
int unarc_one(char string[],int meth_number)
{
   char string2[FLENGTH];    /* build the dos commands in the string */
   int before;

   check_for_key();
   my_printf("Unarching ");
   my_printf(string);
   my_printf("\n");
   if (dest_directory[0]!=NULL) {
      cd(dest_directory);
      strcpy(string2,source_directory);

      if (string2[strlen(string2)-1]!='\\')
         strcat(string2,"\\");

      strcat(string2,string);
      strcpy(string,string2);
   }
   string2[0]=NULL;
   if (answer_y==TRUE)
      strcat(string2,"ECHO Y\nY\nY\nY\nY\nY\nY\nY\nY\nY\nY\nY\n | ");

   strcat(string2,method[meth_number]);
   strcat(string2," ");
   strcat(string2,string);

   strcat(string2,partial);
   strcat(string2,redirect_to);

   before=fcount();
   system(string2);

   if (fcount()>before)
      unlink(string);

   cd(source_directory);
   return TRUE;
}
/******************************************************************/
int fcount()                             /* count number of files */
{
   int done,counter=0;
   struct ffblk ffblk;

   if (delete_behind==ON) {
      done=findfirst("*.*",&ffblk,0);
      while (!done) {
         if (!(redirect_to[0]!=NULL && strstr(redirect_to,ffblk.ff_name)==NULL))
            counter++;
         done=findnext(&ffblk);
      }
   }
   return counter;
}
/********************************************************************/
void parse_comm_line(int argc,char *argv[])
{
/* Parse the command line parameters */

   int the_files=FALSE,option,on_off,i;
   char *cur_argv;

   for (i=1;i<argc;i++) {
      cur_argv=argv[i];    /* reduce all those argv[i] to an exact address */
      strupr(cur_argv);
      if (cur_argv[0]=='-' || cur_argv[0]=='/') {  /* dash option */
         option=cur_argv[1];
         if (cur_argv[2]==NULL)    /* parameter continues on next */
            cur_argv = argv[++i];
         else
            cur_argv+=2;           /* advance it 2 characters */

         on_off = stricmp(cur_argv,"ON")==0;
         if (option=='S') {        /* Smart mode on/off/always */
            if (stricmp(cur_argv,"ALWAYS")==0)
               smart=ALWAYS;
            else
               smart = on_off;
         }
         else if (option=='D')          /* Delete behind on/off */
            delete_behind = on_off;
         else if (option=='R')          /* Recursive on/off */
            recurse = on_off;
         else if (option=='X')
            self_extracts = on_off;
         else if (option=='Y')
            answer_y = on_off;
         else if (option=='P') {
            strcat(partial," ");
            strcat(partial,cur_argv);
         }
         else if (option=='O') {
            strcpy(redirect_to," >>");
            strcat(redirect_to,cur_argv);
         }
         else if (option=='C')
            cfgfile=cur_argv;
         else if (option=='?') {
            my_printf("Command line parameters:\n-----------------------\n");
            my_printf("-Don / -Doff  Delete_behind on/off\n");
            my_printf("-Son / -Soff / -Salways  Smart_mode on/off/always\n");
            my_printf("-Ron / -Roff  Recurse on/off\n");
            my_printf("-Xon / -Xoff  self eXtracts on/off\n");
            my_printf("-Yon / -Yoff  answer Y to file already exists questions\n");
            my_printf("-P<file_spec> Partial Unarc\n");
            my_printf("-c<file>      alternate Configuration file\n");
            my_printf("-o<file>      Redirect_to\n");
            exit (0);
         }
         else {
            char string[2];
            my_printf("Invalid Command Line Parameter ");
            string[0]=option;
            string[1]=NULL;
            my_printf(string);
            exit(0);
         }
      }
      else {
         if (!the_files) {    /* specifying the file(s) to unarc */
            int j,k=0;

            for (j=strlen(cur_argv);j>=0;j--) {
               if (cur_argv[j]=='\\' || cur_argv[j]==':')  {
                  while (k<=j) {
                     source_directory[k]=cur_argv[k];
                     k++;
                  }
                  cur_argv+=k;              /* advance k characters */
                  source_directory[k]=NULL;
                  break;
               }
            }
            the_files=TRUE;
            strcpy(look_through,cur_argv);
         }
         else {
            if (strstr(cur_argv,"*")) {
               strcat(partial," ");
               strcat(partial,cur_argv);
            }
            else
               strcpy(dest_directory,cur_argv);
         }
      }
   }
   if (look_through[0]==NULL || !the_files)
      strcpy(look_through,"*.*");

   if (!strstr(look_through,"."))
      strcat(look_through,".*");

}
